unit JPGComment;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TJPGComment = class(TComponent)
  private
         Fname : string;
         Fcomment : string;
         procedure SetFilename (Filename : string);
         procedure SetComment (CommentString : string);
         function GetByte ( var f : TMemoryStream) : byte;
         procedure SetByte ( var f : TMemoryStream; b : byte);
  protected
  public
  published
  property FileName : string read Fname write SetFilename;
  property Comment : string read fcomment write setcomment;
  procedure ReadComment;
  procedure WriteComment;
  end;

procedure Register;

implementation

procedure Tjpgcomment.SetFilename( Filename : string);
begin
     Fname:=Filename;
end;

procedure Tjpgcomment.SetComment( CommentString : string);
begin
     Fcomment:=CommentString;
end;

function Tjpgcomment.getbyte( var F : TMemoryStream) : byte;
var
  b : byte;
begin
     F.Read(b,1);
     getbyte:=b;
end;

procedure TJPGComment.SetByte(var F: TMemoryStream; b: byte);
begin
  F.Write(b,1);
end;

procedure Tjpgcomment.ReadComment;
var F : TMemoryStream;
    a,s1,s2,l1,l2 : byte;
    i,k : longint;
    s,r : string;
begin
     F:=TMemoryStream.Create;
     r:=''; s:='';
     f.LoadFromFile(fname);

     a:=getbyte(F); a:=getbyte(F);
     repeat
     repeat until getbyte(F)=$ff;
           s1:=$ff; s2:=getbyte(F);
           l1:=getbyte(F); l2:=getbyte(F);
           s:='';
           k:=(256*l1+l2)-2;
           for i:=1 to k do
               if F.Position<=F.Size then
                     begin
                     s:=concat(s,chr(getbyte(F)));
                     //ShowMessage(s);
                     end;
           if s2=$FE then r:=s;
     until (F.Position=F.Size) or (s2=$da);
     F.Free;
     SetComment(r);
end;


procedure Tjpgcomment.WriteComment;
var Src,Dst : TMemoryStream;
    a,s1,s2,l1,l2 : byte;
    I : LongInt;
    s,r : string;
    notyet : boolean;
begin
     Src:=TMemoryStream.Create;
     Dst:=TMemoryStream.Create;
     r:=''; s:='';
     notyet:=true;
     Src.LoadFromFile( Fname );
     a:=getbyte(Src); setbyte(Dst,a);
     a:=getbyte(Src); setbyte(Dst,a);
     repeat
           repeat until getbyte(Src)=$ff;
           s1:=$ff; s2:=getbyte(Src);
           l1:=getbyte(Src); l2:=getbyte(Src);
           s:='';
           for i:=1 to (256*l1+l2)-2 do
               if (Src.Position<=Src.Size) then
                             begin
                             s:=concat(s,chr(getbyte(Src)));
                             end;
           if ((s2 and $F0)=$C0) and notyet and (fcomment<>'') then
              begin
              a:=$FF; Setbyte(Dst,a);
              a:=$FE; Setbyte(Dst,a);
              a:=(length(comment)+2) div 256;
              Setbyte(Dst,a);
              a:=(length(comment)+2) mod 256;
              Setbyte(Dst,a);
              for i:=1 to length(comment) do
                  begin
                  a:=ord(comment[i]);
                  Setbyte(Dst,a);
                  end;
              notyet:=false;
              end;
           if s2<>$FE then
              begin
              Setbyte(Dst,s1);
              Setbyte(Dst,s2);
              Setbyte(Dst,l1);
              Setbyte(Dst,l2);
              for i:=1 to length(s) do
                 begin
                 a:=ord(s[i]);
                 Setbyte(Dst,a);
                 end;
              end;
     until (Src.Position=Src.Size) or (s2=$da);

     Dst.CopyFrom(Src,Src.Size-Src.Position);
     Dst.SaveToFile(Fname);
     Src.Free;
     Dst.Free;
end;


procedure Register;
begin
  RegisterComponents('Samples', [TJPGComment]);
end;



end.
