program MICAM;

uses
  Windows,
  Dialogs,
  Forms,
  MICAMMainUnit in 'MICAMMainUnit.pas' {Main},
  DlgDriver in 'DlgDriver.pas' {DriverDlg},
  Preferences in 'Preferences.pas' {PrefDlg},
  AboutMICAM in 'AboutMICAM.pas' {AboutDlg},
  HelpUnit in 'HelpUnit.pas' {Help},
  SaveOptions in 'SaveOptions.pas' {SaveWithOptions},
  MicamUtils in 'MicamUtils.pas',
  SearchUnit in 'SearchUnit.pas' {SearchForm};

var
  Mutex : THandle;

{$R *.RES}

begin
  Mutex:=CreateMutex(nil,True,'MICAM');
  if (Mutex <> 0) and (GetLastError = 0) then
  begin
  Application.Initialize;
  Application.CreateForm(TMain, Main);
  Application.CreateForm(TSaveWithOptions, SaveWithOptions);
  Application.CreateForm(TDriverDlg, DriverDlg);
  Application.CreateForm(TAboutDlg, AboutDlg);
  Application.CreateForm(THelp, Help);
  Application.CreateForm(TSearchForm, SearchForm);
  Application.Run;
  if Mutex <> 0 then CloseHandle(Mutex);
  end
  else ShowMessage('MICAM is already running, You cannot start another version');
end.
